<?
    if (!$authenticated) {
	echo $unauthorized;
	return 0;
    }

    $rules = @file($UDEV_FILE);
    $rules_orig = $rules;

    $props = array();
    $dprops = array();	// Device properties only
    $iprops = array();	// Iterface properties only
    
    $device = $_POST["device"];
    if ($device) unset($_POST["device"]);
    else {
        echo "<span class=\"highlight\">Error:</span> Device not specified!";
	return 0;
    }
    
    $usb_props_uc = strtoupper($USB_PROPS);
    
    foreach($_POST as $name=>$value) {
	$props[$name] = $value;
	if (preg_match("/^" . $USB_PROPS . "$/i", $name)) {
	    $dprops[$name] = $value;
	} else {
	    $iprops[$name] = $value;
	}
    }
    
    if (sizeof($iprops)) {
	$iline = 'KERNEL="ttyUSB[0-9]*", ';
	foreach ($iprops as $name=>$value) {
	    $value = preg_replace($UDEV_REGEXP, "*", $value);
	    $iline .= "SYSFS{" . $name . "}==\"$value\", ";
	}
    }    
    

    $ivalue = 0; $imaxvalue = 0;
    
    if ($rules) {
	foreach ($rules_orig as $pos=>$rule) {
	    $valid = check_udev_full_validity($props, $rules_orig, $rule);
	    if ($valid) unset($rules[$pos]);
	    else if ((sizeof($iprops))&&(preg_match("/ENV{Interface}=\"([^\"]+)\"/i", $rule, $m))) {
		if (check_udev_validity($iprops, $rule)) {
		    // Our interface props are equal or weaker then the current rule.
		    if (!strncmp($iline, $rule, strlen($iline))) {
			// Stronger or equal. => Equal. (Will set reference)
			unset($iline);
		    } else {
			// Weaker or Invalid. (Discarding. Other devices should be reconfigured.)
			unset($rules[$pos]);
			// Not discarding devices, since most probably they just need to use new rule.
		    }
		    $ivalue = $m[1];
		} else {
		    if ($m[1]>$imaxvalue) $imaxvalue = $m[1];
		}
	    }
	}

	foreach ($rules as $pos=>$rule) {
	    if (preg_match("/SYMLINK\+=\"adas-usb\/$device\"/", $rule)) {
	        echo "<span class=\"highlight\">Error:</span> Device ($device) already configured!";
		return 0;
	    }
	}
    }
    
    $line = 'KERNEL="ttyUSB[0-9]*", ';
    if (sizeof($iprops)) {
	if (!$ivalue) $ivalue = $imaxvalue + 1;
	$line .= "ENV{Interface}==\"$ivalue\", ";
    }

    foreach ($dprops as $name=>$value) {
	$value = preg_replace($UDEV_REGEXP, "*", $value);
	$line .= "SYSFS{" . $name . "}==\"$value\", ";
    }
    $line .= "SYMLINK+=\"adas-usb/usb-$device\"";
    
    $fp = @fopen($UDEV_FILE, "w");
    if (!$fp) {
        echo "<span class=\"highlight\">Error:</span> Can't open $UDEV_FILE for writing!";
	return 0;
    }
    
    if (sizeof($iprops)) {
	if ($iline) fwrite($fp, $iline . "ENV{Interface}=\"$ivalue\"\n");
    }

    if ($rules) {    
	foreach ($rules as $rule) {
	    if (!preg_match("/^\s+$/", $rule)) {
	        $rule = preg_replace("/[\s\n]+$/","", $rule);
		fwrite($fp, $rule . "\n");
	    }
	}
    }
    fwrite($fp, $line . "\n");

    fclose($fp);
    
    echo "Done";
?>
<script type="text/javascript">location.replace("index.php?page=usb.xml");</script>
